"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
// eslint-disable-next-line import/no-extraneous-dependencies
var react_dom_1 = require("react-dom");
var valid_types_1 = require("valid-types");
var error_helpers_1 = require("./error-helpers");
var Bsod = function (props) {
    var actions = props.stackData.actions;
    var cError = actions[actions.length - 1] ? actions[actions.length - 1][(0, error_helpers_1.getCritical)()] : {};
    return (0, react_dom_1.createPortal)((0, jsx_runtime_1.jsx)("div", __assign({ style: {
            background: '#00a',
            color: '#b3b3b3',
            fontFamily: 'courier',
            fontSize: '14px',
            height: '100%',
            left: 0,
            position: 'fixed',
            top: 0,
            width: '100%',
            zIndex: 10000,
        } }, { children: (0, jsx_runtime_1.jsxs)("div", __assign({ style: {
                height: '100%',
                position: 'relative',
                width: '100%',
            } }, { children: [(0, valid_types_1.isFunction)(props.onClose) && ((0, jsx_runtime_1.jsx)("button", __assign({ type: "button", onClick: props.onClose, style: {
                        WebkitAppearance: 'none',
                        background: '#eee',
                        border: 0,
                        cursor: 'pointer',
                        fontSize: '24px',
                        height: '30px',
                        lineHeight: '25px',
                        position: 'absolute',
                        right: '25px',
                        textAlign: 'center',
                        top: '25px',
                        width: '30px',
                        zIndex: 1000,
                    } }, { children: "X" }))), cError && ((0, jsx_runtime_1.jsx)("h2", __assign({ style: {
                        background: '#b3b3b3',
                        color: '#00a',
                        display: 'inline-block',
                        fontFamily: 'courier',
                        fontSize: '18px',
                        fontWeight: 'bold',
                        margin: '0 auto',
                        padding: '0.25em 0.5em',
                    } }, { children: cError.stack[0] || cError.message || '' }))), (0, jsx_runtime_1.jsxs)("div", __assign({ style: {
                        fontSize: '1rem',
                        margin: '2em',
                        textAlign: 'left',
                    } }, { children: [cError && (0, valid_types_1.isArray)(cError.stack) && ((0, jsx_runtime_1.jsxs)("pre", __assign({ style: {
                                background: 'none',
                                border: 0,
                                color: 'rgb(179, 179, 179)',
                                font: '10px/13px Lucida Console, Monaco, monospace',
                                margin: '0 0 10px',
                            } }, { children: ["$", cError.stack.join('\n')] }))), (0, jsx_runtime_1.jsx)("h4", { children: "Actions:" }), actions.length > 0 ? ((0, jsx_runtime_1.jsx)("ol", __assign({ reversed: true, style: {
                                fontSize: '13px',
                                listStyle: 'list-item',
                            }, start: props.count || actions.length - 1 }, { children: (function () {
                                var listOfActions = actions
                                    .filter(function (action) {
                                    if (!(0, valid_types_1.isObject)(action)) {
                                        return false;
                                    }
                                    var type = Object.keys(action)[0];
                                    if (!type) {
                                        return false;
                                    }
                                    return !(0, error_helpers_1.isCritical)(type);
                                })
                                    .map(function (action) {
                                    if (!(0, valid_types_1.isObject)(action)) {
                                        return false;
                                    }
                                    var type = Object.keys(action)[0];
                                    if (!type) {
                                        return false;
                                    }
                                    var actionMessage = action[type];
                                    return {
                                        actionMessage: actionMessage,
                                        type: type,
                                    };
                                })
                                    .filter(Boolean)
                                    .reverse();
                                return listOfActions.map(function (_a, index) {
                                    var actionMessage = _a.actionMessage, type = _a.type;
                                    return ((0, jsx_runtime_1.jsx)("li", { children: (0, jsx_runtime_1.jsx)("p", { children: (0, jsx_runtime_1.jsxs)("strong", { children: [type, ": ", actionMessage] }) }) }, index));
                                });
                            })() }))) : ((0, jsx_runtime_1.jsx)("div", { children: "Nothing actions" }))] }))] })) })), document.body);
};
// eslint-disable-next-line import/no-default-export
exports.default = Bsod;
//# sourceMappingURL=bsod.js.map