import { Component, FunctionComponent, PropsWithChildren } from 'react';
import { IBSOD } from './bsod';
import { IStack, ILogger } from './types';
interface ILoggerContext {
    getStackData: () => IStack;
    onError: (stack: IStack) => void;
}
export declare const LoggerContext: import("react").Context<ILoggerContext>;
interface ILoggerApi {
    getStackData: () => IStack;
    triggerError: (stack: IStack) => void;
}
export declare const useLoggerApi: () => ILoggerApi;
interface ILoggerContainerProps {
    logger?: ILogger;
    active?: boolean;
    bsodActive?: boolean;
    sessionID?: boolean | string | number;
    bsod?: FunctionComponent<IBSOD>;
    limit?: number;
    getCurrentDate?: () => string;
    onError?: (stack: IStack) => void;
    onPrepareStack?: (stack: IStack) => IStack;
    stdout?: (level: string, message: string, important?: boolean) => void;
}
interface ILoggerContainerState {
    bsod: boolean;
}
export default class LoggerContainer extends Component<PropsWithChildren<ILoggerContainerProps>, ILoggerContainerState> {
    private __hasCriticalError;
    private readonly stack;
    constructor(props?: ILoggerContainerProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    handlerError: (e: ErrorEvent) => void;
    _onMouseDown: (e: MouseEvent) => void;
    _onKeyDown: (e: KeyboardEvent) => void;
    _onKeyUp: () => void;
    _onMouseUp: () => void;
    getStackData: () => IStack;
    onError: (stackData: IStack) => void;
    closeBsod: () => void;
    bindActions(): void;
    unbindActions(): void;
    render(): JSX.Element;
}
export {};
