import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
// eslint-disable-next-line import/no-extraneous-dependencies
import { createPortal } from 'react-dom';
import { isArray, isObject, isFunction } from 'valid-types';
import { isCritical, getCritical } from './error-helpers';
const Bsod = (props) => {
    const { actions } = props.stackData;
    const cError = actions[actions.length - 1] ? actions[actions.length - 1][getCritical()] : {};
    return createPortal(_jsx("div", Object.assign({ style: {
            background: '#00a',
            color: '#b3b3b3',
            fontFamily: 'courier',
            fontSize: '14px',
            height: '100%',
            left: 0,
            position: 'fixed',
            top: 0,
            width: '100%',
            zIndex: 10000,
        } }, { children: _jsxs("div", Object.assign({ style: {
                height: '100%',
                position: 'relative',
                width: '100%',
            } }, { children: [isFunction(props.onClose) && (_jsx("button", Object.assign({ type: "button", onClick: props.onClose, style: {
                        WebkitAppearance: 'none',
                        background: '#eee',
                        border: 0,
                        cursor: 'pointer',
                        fontSize: '24px',
                        height: '30px',
                        lineHeight: '25px',
                        position: 'absolute',
                        right: '25px',
                        textAlign: 'center',
                        top: '25px',
                        width: '30px',
                        zIndex: 1000,
                    } }, { children: "X" }))), cError && (_jsx("h2", Object.assign({ style: {
                        background: '#b3b3b3',
                        color: '#00a',
                        display: 'inline-block',
                        fontFamily: 'courier',
                        fontSize: '18px',
                        fontWeight: 'bold',
                        margin: '0 auto',
                        padding: '0.25em 0.5em',
                    } }, { children: cError.stack[0] || cError.message || '' }))), _jsxs("div", Object.assign({ style: {
                        fontSize: '1rem',
                        margin: '2em',
                        textAlign: 'left',
                    } }, { children: [cError && isArray(cError.stack) && (_jsxs("pre", Object.assign({ style: {
                                background: 'none',
                                border: 0,
                                color: 'rgb(179, 179, 179)',
                                font: '10px/13px Lucida Console, Monaco, monospace',
                                margin: '0 0 10px',
                            } }, { children: ["$", cError.stack.join('\n')] }))), _jsx("h4", { children: "Actions:" }), actions.length > 0 ? (_jsx("ol", Object.assign({ reversed: true, style: {
                                fontSize: '13px',
                                listStyle: 'list-item',
                            }, start: props.count || actions.length - 1 }, { children: (() => {
                                const listOfActions = actions
                                    .filter((action) => {
                                    if (!isObject(action)) {
                                        return false;
                                    }
                                    const type = Object.keys(action)[0];
                                    if (!type) {
                                        return false;
                                    }
                                    return !isCritical(type);
                                })
                                    .map((action) => {
                                    if (!isObject(action)) {
                                        return false;
                                    }
                                    const type = Object.keys(action)[0];
                                    if (!type) {
                                        return false;
                                    }
                                    const actionMessage = action[type];
                                    return {
                                        actionMessage,
                                        type,
                                    };
                                })
                                    .filter(Boolean)
                                    .reverse();
                                return listOfActions.map(({ actionMessage, type }, index) => (_jsx("li", { children: _jsx("p", { children: _jsxs("strong", { children: [type, ": ", actionMessage] }) }) }, index)));
                            })() }))) : (_jsx("div", { children: "Nothing actions" }))] }))] })) })), document.body);
};
// eslint-disable-next-line import/no-default-export
export default Bsod;
//# sourceMappingURL=bsod.js.map